package com.progwml6.natura.world.worldgen.trees;

import com.mojang.serialization.Codec;
import com.progwml6.natura.world.NaturaStructures;
import net.minecraft.block.BlockState;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.gen.blockstateprovider.BlockStateProvider;
import net.minecraft.world.gen.blockstateprovider.BlockStateProviderType;

import java.util.Random;
import java.util.function.Supplier;

public class SupplierBlockStateProvider extends BlockStateProvider {

  public static final Codec<SupplierBlockStateProvider> CODEC =
    BlockState.CODEC.fieldOf("state")
      .xmap(SupplierBlockStateProvider::new, (provider) -> provider.supplier.get()).codec();

  private final Supplier<BlockState> supplier;

  private SupplierBlockStateProvider(BlockState state) {
    this(() -> state);
  }

  public SupplierBlockStateProvider(Supplier<BlockState> blockStateSupplier) {
    this.supplier = blockStateSupplier;
  }

  @Override
  protected BlockStateProviderType<?> getProviderType() {
    return NaturaStructures.supplierBlockstateProvider.get();
  }

  @Override
  public BlockState getBlockState(Random randomIn, BlockPos blockPosIn) {
    return this.supplier.get();
  }
}
